package de.ivu.elect.presentation.praesentation.menu;

import java.util.List;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebnis.entity.Praesentationsexportart;
import de.ivu.elect.business.ergebnis.entity.Stimmabgabeart;
import de.ivu.elect.business.internet.boundary.InternetPraesentationErmittler;
import de.ivu.elect.business.internet.boundary.PraesentationsexportExtendedDAO;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.ergebnis.menu.ErgebnisMenuDisabled;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;


import static java.util.Collections.singletonList;

public abstract class AbstractPraesentationOeffnenMenuItemEntry extends AbstractMenuItemEntry {
  private static final long serialVersionUID = 1L;

  @Inject
  protected transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  @Inject
  protected transient PraesentationsexportExtendedDAO praesentationsexportExtendedDAO;

  @Inject
  protected transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient InternetPraesentationErmittler internetPraesentationErmittler;

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.PRAESENTATION_OEFFNEN) && internetPraesentationErmittler.getInternetPraesentationTyp()
        .isPraesentationVerfuegbar();
  }

  @Override
  protected boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || !isPraesentationIsErstellt();
  }

  private boolean isPraesentationIsErstellt() {
    Ergebnis ergebnis = ergebnisSessionSelect.getEntity();
    if (ergebnis == null) {
      return false;
    }
    Long countErgebnisAndArten = praesentationsexportExtendedDAO.findByCountErgebnisAndArten(ergebnis, Praesentationsexportart.INTERNET, Stimmabgabeart.GESAMT);
    return countErgebnisAndArten != null && countErgebnisAndArten > 0L;

  }

  @Override
  protected boolean isShowBlockUi() {
    return false; // wird in neuem Browserfenster geöffnet, daher kein BlockUi
  }

  @Nullable
  @Override
  public String getTargetViewId() {
    return getUrl();
  }

  protected abstract String getUrl();

  @Override
  protected String buildUrlForTargetViewId(String viewID) {
    return viewID;
  }

  @Nullable
  @Override
  public String getTarget() {
    return TARGET_EXTERN;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return singletonList("");
  }
}
